<?php

defined('ABSPATH') || die('Access denied!'); 

register_activation_hook(JSPPRISM_PLUGIN_FILE,function(){
    global $wpdb; 
	$charset_collate = $wpdb->get_charset_collate();
	$table_name = $wpdb->prefix . 'photo_table'; // photo table

	$sql = "CREATE TABLE $table_name (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		user_id mediumint(9) NOT NULL,
		date datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
        name varchar(100),
        selected boolean,
        url varchar(100) NOT NULL,
        edited boolean,
        photo_id varchar(30),
		UNIQUE KEY id (id)
	) $charset_collate;";

	require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
	dbDelta( $sql );
});


register_deactivation_hook(JSPPRISM_PLUGIN_FILE,function(){

    global $wpdb;
    $prefix = $wpdb->prefix;
    $sql ="DROP TABLE IF EXISTS`{$prefix}photo_table`;";
    $wpdb->query($sql);
});

// function to upload images and ivite user save data in DB

if ( !function_exists( 'insert_invited_user_date' ) ) {
    function insert_invited_user_date(){

        $user_name = sanitize_text_field($_POST['strUserName']);
        $user_email = sanitize_text_field($_POST['strUserEmail']);
        $user_phone = sanitize_text_field($_POST['strUserPhone']);
        $password  = wp_generate_password(12);
        $hasError = false;
        if($_POST['submittedInviteForm']){
            if(trim($_POST['strUserEmail']) === '') {
                $nameError = 'Please enter User Email.';
                $hasError = true;
            }else if(email_exists($user_email) == true){
                $user = get_user_by( 'email', $user_email );
                $nUserId = $user->ID;
            }
            
    // upload files 
            if($hasError){
                echo 'ERROR: ' . $nameError;
                die;
            }
            if ( $_FILES) { 
                $files = $_FILES["photofile"]; 
                if(empty($nUserId))
                    $user_id = createNewUser($user_email ,$user_name , $user_phone , $password);
                else 
                    $user_id = $nUserId;
                foreach ($files['name'] as $key => $value) { 
                    if ($files['name'][$key]) { 
                        $file = array( 
                            'name' => $files['name'][$key],
                            'type' => $files['type'][$key], 
                            'tmp_name' => $files['tmp_name'][$key], 
                            'error' => $files['error'][$key],
                            'size' => $files['size'][$key]
                        );
                        $_FILES = array ("my_file_upload" => $file); 
                    $file_name = $files['name'][$key];
                        foreach ($_FILES as $file => $array) {   
                                    
                            $attachment_id = media_handle_upload( $file, 0 );
                            if( $attachment_id){
                                $photo_url = wp_get_attachment_url($attachment_id);
                                $param_arr = array();
                                $param_arr['file_name'] = $file_name;
                                $param_arr['file_url'] = $photo_url;
                                $param_arr['photo_id'] = $attachment_id;
                                $param_arr['user_id'] = $user_id;
                                $param_arr['edited'] = 0;
                                insert_photo_data($param_arr);
                                echo "File added ".$file_name." and user invited successfully <br>";
                        }else{
                            echo $files['name'][$key] . 'not uploaded';
                        }
                        }
                    }
                } 
            }
            sendEmail($user_email , "", $password); // send email to user 
        }

    }
}

if ( !function_exists( 'insert_final_photos' ) ) {
    function insert_final_photos(){
        $user_id = sanitize_text_field($_POST['nUserId']);
        $hasError = false;
        if($_POST['submittedFinalForm']){
            if(trim($_POST['nUserId']) === '') {
                $nameError = 'Please select user.';
                echo  $nameError;
                $hasError = true;
                die();
            }
        }
        if ( $_FILES) { 
            $files = $_FILES["finalphotofile"]; 
            foreach ($files['name'] as $key => $value) { 
                if ($files['name'][$key]) { 
                    $file = array( 
                        'name' => $files['name'][$key],
                        'type' => $files['type'][$key], 
                        'tmp_name' => $files['tmp_name'][$key], 
                        'error' => $files['error'][$key],
                        'size' => $files['size'][$key]
                    );
                    $_FILES = array ("my_file_upload" => $file); 
                $file_name = $files['name'][$key];
                    foreach ($_FILES as $file => $array) {   
                                
                        $attachment_id = media_handle_upload( $file, 0 );
                        if( $attachment_id){
                            $photo_url = wp_get_attachment_url($attachment_id);
                            $param_arr = array();
                            $param_arr['file_name'] = $file_name;
                            $param_arr['file_url'] = $photo_url;
                            $param_arr['photo_id'] = $attachment_id;
                            $param_arr['user_id'] = $user_id;
                            $param_arr['edited'] = 1;
                            insert_photo_data($param_arr);
                            echo "File added successfully ".$file_name." <br>";
                    }else{
                        echo $files['name'][$key] . 'not uploaded';
                    }
                    }
                }
            } 
        }
        $userArray = get_user_by( 'id', $user_id );
        sendEmail($userArray->user_email , "final" , ""); // send email to user 
    }
}
if ( !function_exists( 'insert_photo_data' ) ) {
    function insert_photo_data($arr){
        global $wpdb;
        $table_name = $wpdb->prefix . 'photo_table';
        $nRecId = $wpdb->insert( $table_name, array(
            'user_id' => $arr['user_id'],
            'name' => $arr['file_name'],
            'selected' => 0,
            'url' => $arr['file_url'],
            'photo_id' => $arr['photo_id'],
            'edited' => $arr['edited'],
        ));

        if(!$nRecId){
            echo 'There was error in inerting record.';
        }
        
    }
}

if ( !function_exists( 'createNewUser' ) ) {
    function createNewUser($email , $name , $phone ,$password){
        global $wpdb;
        $table_name  = $wpdb->prefix."users";
        $username = $email;
        $user_id = wp_create_user( $username, $password, $email );

        $result = $wpdb->update($table_name,array( 'user_nicename' => $name,	'display_name' => $name	),
        array( 'ID' =>  $user_id), array( '%s',	'%s'), array( '%d' ));
        return $user_id;
    }
}
if ( !function_exists( 'sendEmail' ) ) {
    function sendEmail($email , $final = "" , $password = ""){
        $to = $email;
        $subject = '[Photo Grapher] Your username and password.';
        $body = 'Photos are uploaded for you.please login and check photos.<br> Your account info <br> Username: ' . $email . " <br> Password: " . $password;
        if(!empty($final)){
            $subject = '[Photo Grapher] Final photos.';
            $body = ' Your selected photos are uploaded. Now you can download photos.';
        }
        $login_url = home_url();
        $body .= " Here is you link to login <a href='" . $login_url . "'>" . $login_url . "</a>";
        $headers = array('Content-Type: text/html; charset=UTF-8');

        $resp = wp_mail( $to, $subject, $body, $headers );
    }
}
if ( !function_exists( 'jspprism_get_users' ) ) {
function jspprism_get_users(){
    global $wpdb;
    $html = '';
    $photo_user = $wpdb->get_results( "SELECT distinct user_id FROM {$wpdb->prefix}photo_table", OBJECT );
    if ($photo_user){
        foreach ($photo_user as $user) {
            $userArray = get_user_by( 'id', $user->user_id );
            if(!empty($userArray->user_nicename)){
            $html .= '<option value="'.$user->user_id.'">'.$userArray->user_nicename.'</option>';
            }
        }

    }

    return $html ;
}
}
if ( !function_exists( 'jspprism_get_names' ) ) {
function jspprism_get_names($id){
    global $wpdb;
    $html = '';
    
        
            $userArray = get_user_by( 'id', $id );
            $html = $userArray->display_name ;
        

    return $html ;
}
}

if ( !function_exists( 'jspprism_user_images' ) ) {
function jspprism_user_images($user_id){
    global $wpdb;
    $output ='';
    $sql = "SELECT * FROM {$wpdb->prefix}photo_table WHERE user_id = '".$user_id."' and edited = '0' ";

    $photos = $wpdb->get_results( $sql, OBJECT );
    foreach ($photos as $photo) {
            $button = "";
            $buttonText = "Select Photo";
            $photo->selected == 1 ? $button = 'checked' : $button = '';
            $photo->selected == 1 ? $buttonText = 'Unselect Photo' : $buttonText = 'Select Photo';
            $output .= '<div class="col-md-3 photo-grid">
            <div class="photo "><img src="'.$photo->url.'"></div>
            <div class="checkbox photo-select-CB">
                <button data-checked="'.$button.'" data-id='.$photo->id.' type="button" class="btn btn-success select-photo">'.$buttonText.'</button>
              </div>
          </div>';
    }
    if(empty($photos)){
        $output .= '<div class="col-md-12 text-center photo-grid">
            <p class="empty-photos">No photos have been uploaded for you yet.Please check back later.</p>
        </div>';
    }
    return $output;
}
}

if ( !function_exists( 'jspprism_edited_images' ) ) {
function jspprism_edited_images($user_id){
global $wpdb;
    $output ="";
     $sql = "SELECT * FROM {$wpdb->prefix}photo_table WHERE user_id = '".$user_id."' and edited = '1' ";
     $photos = $wpdb->get_results( $sql, OBJECT );

     foreach ($photos as $photo) {
                $output .= '<div class="col-md-3 photo-grid">
                <div class="photo "><img src="'.$photo->url.'"></div>
                <div class="checkbox photo-select-download">
                <form method="post">
                <input type="hidden" name="checked" value="'.$photo->url.'">
                <a href="'.$photo->url.'" download class="btn btn-success download-photo">Download</a>
                    </form>
                </div>
            </div>';
    }
    if(empty($photos)){
        $output .= '<div class="col-md-12 text-center photo-grid">
            <p class="empty-photos">No photos have been uploaded for you yet.Please check back later.</p>
        </div>';
    }
    return $output;
}
}

