<?php

/* 

//    Plugin Name: Photoprism
//    Author:  The Web Design Hub LLC
//    Description: This plugin allows the user to select the photos and send to edit them .     
//    version: 1.0.0

*/

defined('ABSPATH') || die('Accesss denied!');


// jspprism_ = JAMESEALSPHOTOPRISM

if( !defined("JSPPRISM_PLUGIN_PATH"))
{
    define('JSPPRISM_PLUGIN_PATH', plugin_dir_path(__FILE__));

}
if( !defined("JSPPRISM_PLUGIN_FILE"))
{
    define('JSPPRISM_PLUGIN_FILE', __FILE__);

}
if( !defined("JSPPRISM_PLUGIN_DIR"))
{
    define("JSPPRISM_PLUGIN_DIR" , plugin_dir_url(__FILE__));

}

include JSPPRISM_PLUGIN_PATH.'inc/database.php';
include JSPPRISM_PLUGIN_PATH.'inc/load-data.php';

if ( !function_exists( 'jspprism_load_admin_style' ) ) {
    function jspprism_load_admin_style(){
        wp_enqueue_style( 'photo-plugin', plugins_url('/css/style.css?v=2' , __FILE__),false,'1.0','all');
        wp_enqueue_style( 'custom_wp_admin_css' );
    }
}
add_action( 'admin_enqueue_scripts', 'jspprism_load_admin_style' );

add_action( 'init', 'jspprism_script_enqueuer' );

function jspprism_script_enqueuer() {
    
   
    wp_register_script( "my_voter_script", JSPPRISM_PLUGIN_DIR.'/js/scripts.js?v=2', array('jquery') );
    wp_localize_script( 'my_voter_script', 'myAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' )));        

    wp_enqueue_script( 'jquery' );
    wp_enqueue_script( 'jquery-form' );
    wp_enqueue_script( 'my_voter_script' );

    wp_enqueue_style('bootstrap-css', plugins_url('/css/bootstrap.min.css' , __FILE__),'');
    wp_enqueue_script('bootstrap-js', plugins_url('/js/bootstrap.min.js' , __FILE__),'');
    

    wp_enqueue_style( 'photo-plugin', plugins_url('/css/style.css?v=1' , __FILE__),false,'1.0','all');
}



register_activation_hook(__FILE__, function(){  //Plugin activation

    add_option('SP_text_1',''); // adding fields in option table on plugin activation
    add_option('SP_text_2',''); 

    //------------ page creation--------------------
    $page1 = array();
    $page1['post_title']= "My Photo";
    $page1['post_content']= "This page is to select photo";
    $page1['post_status'] = "publish";
    $page1['post_slug'] = "myphoto";
    $page1['post_type'] = "page";

    $page1_id=wp_insert_post($page1);
    add_option('ps_myphoto_page_id',$page1_id );

});

register_deactivation_hook(__FILE__, function(){ // Plugin deactivation
    
    delete_option('SP_text_1'); // deleting fields from option table on plugin deactivation
    delete_option('SP_text_2');

    //------Delete page---------

    $page_id = get_option('ps_myphoto_page_id');
    wp_delete_post($page_id);
    delete_option('ps_myphoto_page_id');
});

add_action('admin_menu','jspprism_SP_menu'); //hook to add Select Photo menu in admin menu
add_action("wp_ajax_jspprism_my_photos", "jspprism_my_photos");
add_action("wp_ajax_jspprism_user_select_photo", "jspprism_user_select_photo");

if ( !function_exists( 'jspprism_my_photos' ) ) {
    function jspprism_my_photos() {
            global $wpdb;
        $output = '';  
        $user_id =  sanitize_text_field ($_POST["user_id"]);
        if(isset($user_id) ) 
        {  
            if($user_id != '')  
            {  
                $sql = "SELECT * FROM {$wpdb->prefix}photo_table WHERE user_id = '".$user_id."' and edited = '0'";  
            }  
            else  
            {  
                $sql = "SELECT * FROM {$wpdb->prefix}photo_table";  
            } 
            
    
            $photos = $wpdb->get_results( $sql, OBJECT );
            
            foreach ($photos as $photo) {
                $image = "";
                $user="";
                if($photo->selected ){
                        $image = '<span>Photo selected: </span><span>
                        <img class="tick-icon" src="'.JSPPRISM_PLUGIN_DIR.'/img/icon-check.png"></span> ';
                        $user = jspprism_get_names($photo->user_id);                 
                    }

            $output .= '<div class="photo-style">
                <div class="photo"><img src="'.$photo->url.'"></div>
                <div class="details">
                
                <span> '.$image.'</span>
                </div>
            </div>';
            }
            echo $output;  
            exit();
        }
    }
}

if ( !function_exists( 'jspprism_user_select_photo' ) ) {
    function jspprism_user_select_photo(){
        global $wpdb;
        $output = ''; 
        $selected = 0;
        if(!empty($_POST['checked']))
            $selected = 1;
        $table_name = $wpdb->prefix . 'photo_table';
        $image = sanitize_text_field($_POST['image_id']);
        if(isset($image)){
            $result = $wpdb->update($table_name,array( 'selected' => $selected	),
            array( 'id' =>  $image), array( '%d',	'%s'), array( '%d' ));

        }
        exit();
    }
}
if ( !function_exists( 'jspprism_SP_menu' ) ) {
    function jspprism_SP_menu(){

    add_menu_page('Photoprism', 'Photoprism', 'manage_options', 'select_photo', 'jspprism_select_photo_func', JSPPRISM_PLUGIN_DIR . '/img/photo-icon-km.png', 5);
    }
}
if ( !function_exists( 'jspprism_select_photo_func' ) ) {
function jspprism_select_photo_func(){
        settings_errors();
        global $sd_active_tab;
        $sd_active_tab = isset( $_GET['tab'] ) ? $_GET['tab'] : 'upload_photo_and_invite_user'; ?>
    
        <h2 class="nav-tab-wrapper">
        <?php
            do_action( 'sp_settings_tab' );
        ?>
        </h2>
        
        <?php
            do_action( 'sp_settings_content' );



    }
}

add_action( 'sp_settings_tab', 'jspprism_welcome_tab',3 );
if ( !function_exists( 'jspprism_welcome_tab' ) ) {
    function jspprism_welcome_tab(){
        global $sd_active_tab; ?>
    
        <a class="nav-tab <?php echo $sd_active_tab == 'upload_photo_and_invite_user' || '' ? 'nav-tab-active' : ''; ?>" href="<?php echo admin_url( 'admin.php?page=select_photo&tab=upload_photo_and_invite_user' ); ?>"><?php _e( 'Upload Photo & Invite User', 'sd' ); ?> </a>
    
        <a class="nav-tab <?php echo $sd_active_tab == 'upload_final_photos' || '' ? 'nav-tab-active' : ''; ?>" href="<?php echo admin_url( 'admin.php?page=select_photo&tab=upload_final_photos' ); ?>"><?php _e( 'Upload Final Photos', 'sd' ); ?> </a>
    
      
        <?php
    }
}

add_action( 'sp_settings_content', 'sp_welcome_render_options_page' );
if ( !function_exists( 'sp_welcome_render_options_page' ) ) {
    function sp_welcome_render_options_page() {

        global $sd_active_tab;

        ?>

        <div class="tab-content">
        <?php switch($sd_active_tab) :
        case 'upload_photo_and_invite_user':
            ?>
        <form id="postPhotoUser" method="post" enctype="multipart/form-data">
                <p><b>Upload photos and invite user.</b></p>
                <div class="row file_upload_photoplugin">
                <div class="btns_div col-md-12 ">
                    <div class="progress col-md-12">
                        <div class="bar progress-bar progress-bar-success progress-bar-striped"></div>
                        <div class="percent">0%</div>
                    </div>
                </div>
            </div>
            <div class="row file_upload">
                    <div id="status" class="col-md-12"></div>
            </div>

            <input type="hidden" name="submittedInviteForm" id="submittedInviteForm" value="true" />
                <label class="label-photo">Name &nbsp;</label>
                <input type="text" class="photo-input" name="strUserName" value="" />
                <br><br>
                <label class="label-photo">Email &nbsp;</label> 
                <input type="text"   class="photo-input" name="strUserEmail" value="" required /> 
                <br><br>
                <label class="label-photo">Phone</label>
                <input type="text" name="strUserPhone"  class="photo-input" value="" />
            
                <br><br>
                <label class="label-photo"> Upload Photos
                <input type="file" name="photofile[]" multiple required />
                </label>

                <?php submit_button("Invite");?>
            </form>



            <?php
            //echo 'upload_photo_and_invite_user';
            break;
        case 'upload_final_photos':?>
        <form id="postUserId" method="post" >
                <p><b>Please select user to see thier selected photos.</b></p>
            <input type="hidden" name="submittedUserForm" id="submittedUserForm" value="true" />
                <label class="label-photo">Select User &nbsp;</label>
                <select class="photo-select" id="photo-user-email">
                    <option value="">-- SELECT --</option>
                <?php echo jspprism_get_users(); ?>
                </select>
            </form>
            <div id="finalPhotoSection">
            <form id="postPhotoUser" class="uploadFinalPhoto" method="post" enctype="multipart/form-data">
                <p><b>Upload Edited Photos for selected user.</b></p>
                <div class="row file_upload_photoplugin">
                <div class="btns_div col-md-12 ">
                    <div class="progress col-md-12">
                        <div class="bar progress-bar progress-bar-success progress-bar-striped"></div>
                        <div class="percent">0%</div>
                    </div>
                </div>
            </div>
            <div class="row file_upload">
                    <div id="status" class="col-md-12"></div>
            </div>

            <input type="hidden" name="submittedFinalForm" id="submittedFinalForm" value="true" />
            <input type="hidden" name="nUserId" id="nUserId" value="" />
                <label class="label-photo"> Upload Photos
                <input type="file" name="finalphotofile[]" multiple required />
                </label>

                <?php submit_button("upload");?>
            </form>
            </div>
            <h6 style="margin: 20px;">Selected Photos</h6>
            <div id="show_photo_admin">
                <p>Select user to see photos.</p>
            </div>

        <?php
            break;
        default:
            //echo 'Default tab';
            break;
        endswitch; ?>
        </div>
        <?php
    //call function on save form 
    if(isset($_POST['submittedInviteForm'])){
        insert_invited_user_date();
    }

    if(isset($_POST['submittedFinalForm'])){
        insert_final_photos();
    }
        
    }
}


if(isset($_POST['downloadPhoto'])){
    $theFile = sanitize_text_field($_POST['checked']);
    if( ! $theFile ) {
        return;
      }
      //clean the fileurl

      $file_url  = stripslashes( trim( $theFile ) );
      //get filename
      $file_name = basename( $theFile );
      //get fileextension
     
      $file_extension = pathinfo($file_name);
      //security check
      $fileName = strtolower($file_url);

      if(strpos( $file_url , '.php' ) == true)
      {
          die("Invalid file!");
      }
     
      $file_new_name = $file_name;
      $content_type = "";
      //check filetype
      switch( $file_extension['extension'] ) {
            case "png": 
              $content_type="image/png"; 
              break;
            case "gif": 
              $content_type="image/gif"; 
              break;
            case "tiff": 
              $content_type="image/tiff"; 
              break;
            case "jpeg":
            case "jpg": 
              $content_type="image/jpg"; 
              break;
            default: 
              $content_type="application/force-download";
      }
      
      $content_type = apply_filters( "ibenic_content_type", $content_type, $file_extension['extension'] );
   
      header("Expires: 0");
      header("Cache-Control: no-cache, no-store, must-revalidate"); 
      header('Cache-Control: pre-check=0, post-check=0, max-age=0', false); 
      header("Pragma: no-cache");	
      header("Content-type: {$content_type}");
      header("Content-Disposition:attachment; filename={$file_new_name}");
      header("Content-Type: application/force-download");
       
      readfile("{$file_url}");
      exit();

}


add_action('admin_menu','SP_process_form_settings'); // hook to set form settings in Select Photo page
if ( !function_exists( 'SP_process_form_settings' ) ) {
    function SP_process_form_settings(){
        register_setting('SP_option_group', 'SP_option_name');
        $action = sanitize_text_field($_POST['action']);
        if(isset($action ) && current_user_can('manage_options')){
            update_option('SP_text_1', sanitize_text_field($_POST['SP1']));
            update_option('SP_text_2', sanitize_text_field($_POST['SP2']));
        }
    }
}


add_filter('page_template', 'jspprism_my_photo'); //custom page template

if ( !function_exists( 'jspprism_my_photo' ) ) {
    function jspprism_my_photo($page_template){

        global $post;
        $page_slug= $post->post_name;

        if($page_slug=="my-photo")
        {
            $page_template= JSPPRISM_PLUGIN_PATH.'/views/myphoto.php';
        }

        return $page_template;
    }
}



if ( !function_exists( 'jspprism_get_photos_to_select' ) ) {
    function jspprism_get_photos_to_select(){
    $user_id= get_current_user_id();
    return jspprism_user_images($user_id);
    }
}

if ( !function_exists( 'jspprism_get_edited_photos' ) ) {
    function jspprism_get_edited_photos(){
        $user_id= get_current_user_id();
    return jspprism_edited_images($user_id);
    }
}



